#if 0 && defined INTERPRETER_ONLY
/* --------------------------------------------------------------------------
 * Assembly code to call C and Haskell functions 
 *
 * Copyright (c) 1994-1998.
 *
 * $RCSfile: callfun.S,v $
 * $Revision: 1.2 $
 * $Date: 1998/05/21 22:33:00 $
 * ------------------------------------------------------------------------*/
		
	.file "callfun.S"
	
// When we call a Fun, we push the arguments on the stack, push a return
// address and execute the instruction "call callFun_entry" which brings us
// here with a return address on top of the stack, a pointer to
// the FunDescriptor under that and the arguments under that.
// We swap the top arguments so that when we jmp to callFunDesc, the stack
// will look as though we executed "callFunDesc(fDescriptor,arg1,arg2,...)"

	// function call/return - standard entry point
	// we'll have one of these for each calling convention
	// all of which jump to callFunDesc when done
	.globl callFun_entry
	.type  callFun_entry,@function
callFun_entry:	
	popl  %eax   /* FunDescriptor  */
	popl  %edx   /* Return address */
	pushl %eax
	pushl %edx
	jmp   callFunDesc

	// generic function call/return
callFunDesc:
	subl  $8,%esp        /* int/double res1;  */
	pushl %esp           /* &res1             */
	leal  20(%esp),%ecx  /* &arg1             */
	pushl %ecx 
	pushl 20(%esp)       /* fun               */
	call  call_H         // returns result type in %eax
	addl  $20,%esp

	testl %eax,%eax      // '\0' = no result
	jne   .L1
	ret
.L1:
	cmpl  $70,%eax      // 'F' = float result
	jne   .L2
	flds  -8(%esp)
	ret
.L2:
	cmpl  $68,%eax      // 'D' = double result
	jne   .L3
	fldl  -8(%esp)
	ret
.L3:
	movl  -8(%esp),%eax  /* return r          */
	ret

//	fstpl (%ebx) // store a double
//	fstps (%ebx) // store a float

//	fldl (%esi) // load a double (ready for return)
//	flds (%esi) // load a float (ready for return)
	
#endif /* INTERPRETER_ONLY */